CREATE TABLE ispm_schedule_favorite_group
(
    user_cd                        VARCHAR(50) NOT NULL,
    favorite_group_cd              VARCHAR(20) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_date                    VARCHAR(20) NOT NULL,
    PRIMARY KEY (user_cd, favorite_group_cd)
);
CREATE TABLE ispt_todo_file_reference
(
    todo_cd                        VARCHAR(20) NOT NULL,
    file_cd                        VARCHAR(20) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_date                    VARCHAR(20) NOT NULL,
    PRIMARY KEY (todo_cd, file_cd)
);
CREATE TABLE ispt_blog_profile
(
    user_cd                        VARCHAR(50) NOT NULL,
    sex_distinction                VARCHAR(5),
    year_of_birth                  VARCHAR(4),
    date_of_birth                  VARCHAR(5),
    blood_type                     VARCHAR(2),
    home_town_cd                   VARCHAR(20),
    present_address_cd             VARCHAR(20),
    self_introduction              VARCHAR(2000),
    picture_path                   VARCHAR(255),
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (user_cd)
);
CREATE TABLE ispt_blog_friend
(
    user_cd                        VARCHAR(50) NOT NULL,
    friend_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (user_cd, friend_user_cd)
);
CREATE TABLE ispt_blog_users_config
(
    user_cd                        VARCHAR(50) NOT NULL,
    valid_start_date               VARCHAR(19) NOT NULL,
    valid_end_date                 VARCHAR(19) NOT NULL,
    category_mail_flg              VARCHAR(4) NOT NULL,
    friend_mail_flg                VARCHAR(4) NOT NULL,
    comment_mail_flg               VARCHAR(4) NOT NULL,
    message_mail_flg               VARCHAR(4) NOT NULL,
    regular_mail_flg               VARCHAR(4) NOT NULL,
    regular_mail_time              VARCHAR(5),
    normal_address_flg             VARCHAR(4) NOT NULL,
    mobile_address_flg             VARCHAR(4) NOT NULL,
    user_setting_address_flg       VARCHAR(4) NOT NULL,
    user_setting_address           VARCHAR(255),
    default_category_cd            VARCHAR(20),
    default_kind_cd                VARCHAR(20),
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (user_cd)
);
CREATE TABLE ispt_blog_users_forte
(
    user_cd                        VARCHAR(50) NOT NULL,
    forte_cd                       VARCHAR(20) NOT NULL,
    forte_category_cd              VARCHAR(20),
    personal_forte_name            VARCHAR(255),
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (user_cd, forte_cd)
);
CREATE TABLE ispm_blog_forte
(
    forte_cd                       VARCHAR(20) NOT NULL,
    forte_category_cd              VARCHAR(20),
    forte_name                     VARCHAR(128) NOT NULL,
    notes                          VARCHAR(2000),
    sort_key                       DECIMAL(15,0),
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (forte_cd)
);
CREATE TABLE ispt_blog_users_category
(
    user_cd                        VARCHAR(50) NOT NULL,
    category_cd                    VARCHAR(20) NOT NULL,
    kind_cd                        VARCHAR(20) NOT NULL,
    sort_key                       DECIMAL(15,0) NOT NULL,
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(50) NOT NULL,
    PRIMARY KEY (user_cd, category_cd, kind_cd)
);
CREATE TABLE ispm_blog_category
(
    category_cd                    VARCHAR(20) NOT NULL,
    category_name                  VARCHAR(128) NOT NULL,
    notes                          VARCHAR(2000),
    sort_key                       DECIMAL(15,0),
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (category_cd)
);
CREATE TABLE ispm_blog_kind
(
    category_cd                    VARCHAR(20) NOT NULL,
    kind_cd                        VARCHAR(20) NOT NULL,
    kind_name                      VARCHAR(128) NOT NULL,
    notes                          VARCHAR(2000),
    attention_flg                  VARCHAR(4) NOT NULL,
    sort_key                       DECIMAL(15,0),
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (category_cd, kind_cd)
);
CREATE TABLE ispt_blog_message
(
    message_cd                     VARCHAR(20) NOT NULL,
    subject                        VARCHAR(255) NOT NULL,
    message                        VARCHAR(2000) NOT NULL,
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (message_cd)
);
CREATE TABLE ispt_blog_message_receive
(
    message_cd                     VARCHAR(20) NOT NULL,
    receive_user_cd                VARCHAR(50) NOT NULL,
    read_flg                       VARCHAR(4) NOT NULL,
    reply_flg                      VARCHAR(4) NOT NULL,
    apply_friend_flg               VARCHAR(4) NOT NULL,
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (message_cd, receive_user_cd)
);
CREATE TABLE ispt_blog_article
(
    article_cd                     VARCHAR(20) NOT NULL,
    category_cd                    VARCHAR(20),
    kind_cd                        VARCHAR(20),
    title                          VARCHAR(255) NOT NULL,
    contents                       VARCHAR(2000),
    contents_html                  VARCHAR,
    picture_path_01                VARCHAR(255),
    picture_display_position_01    VARCHAR(4),
    picture_path_02                VARCHAR(255),
    picture_display_position_02    VARCHAR(4),
    picture_path_03                VARCHAR(255),
    picture_display_position_03    VARCHAR(4),
    related_article_cd             VARCHAR(20),
    draft_flg                      VARCHAR(4),
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (article_cd)
);
CREATE TABLE ispt_blog_comment
(
    article_cd                     VARCHAR(20) NOT NULL,
    comment_cd                     VARCHAR(20) NOT NULL,
    comments                       VARCHAR(2000) NOT NULL,
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (article_cd, comment_cd)
);
CREATE TABLE ispt_blog_article_file
(
    article_cd                     VARCHAR(20) NOT NULL,
    file_cd                        VARCHAR(20) NOT NULL,
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (article_cd, file_cd)
);
CREATE TABLE ispt_blog_access_all
(
    article_cd                     VARCHAR(20) NOT NULL,
    access_all_count               DECIMAL(15,0) NOT NULL,
    PRIMARY KEY (article_cd)
);
CREATE TABLE ispt_blog_access_each_day
(
    article_cd                     VARCHAR(20) NOT NULL,
    index_cd                       VARCHAR(20) NOT NULL,
    access_count                   DECIMAL(15,0) NOT NULL,
    PRIMARY KEY (article_cd, index_cd)
);
CREATE TABLE ispt_blog_access_history
(
    article_cd                     VARCHAR(20) NOT NULL,
    user_cd                        VARCHAR(50) NOT NULL,
    access_date                    VARCHAR(19) NOT NULL,
    user_name                      VARCHAR(128) NOT NULL,
    PRIMARY KEY (article_cd, user_cd, access_date)
);
CREATE TABLE ispt_bulletin_info
(
    bulletin_cls_cd                VARCHAR(20) NOT NULL,
    bulletin_info_cd               VARCHAR(20) NOT NULL,
    thread_cd                      VARCHAR(20) NOT NULL,
    title                          VARCHAR(255) NOT NULL,
    contents                       VARCHAR(2000),
    contents_html                  VARCHAR,
    notice_cls_cd                  VARCHAR(3),
    notice_start_date              VARCHAR(19),
    notice_end_date                VARCHAR(19),
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    start_date                     VARCHAR(19),
    end_date                       VARCHAR(19),
    PRIMARY KEY (bulletin_info_cd)
);
CREATE TABLE ispt_conference_info
(
    conference_cls_cd              VARCHAR(20) NOT NULL,
    conference_info_cd             VARCHAR(20) NOT NULL,
    thread_cd                      VARCHAR(20) NOT NULL,
    parent_cd                      VARCHAR(20),
    title                          VARCHAR(255),
    contents                       VARCHAR(2000),
    contents_html                  VARCHAR,
    notice_cls_cd                  VARCHAR(3),
    notice_start_date              VARCHAR(19),
    notice_end_date                VARCHAR(19),
    insert_user_cd                 VARCHAR(50) NOT NULL,
    insert_user_name               VARCHAR(128) NOT NULL,
    insert_date                    VARCHAR(19) NOT NULL,
    record_user_cd                 VARCHAR(50) NOT NULL,
    record_user_name               VARCHAR(128) NOT NULL,
    record_date                    VARCHAR(19) NOT NULL,
    PRIMARY KEY (conference_info_cd)
);
CREATE TABLE wbm_account_initial
(
    account_cd                        VARCHAR(20) NOT NULL,
    user_cd                             VARCHAR(50) NOT NULL,
    preview_type                       VARCHAR(1),
    color                                VARCHAR(50)  NOT NULL,
    quick_search                      VARCHAR(1),
    send_format                       VARCHAR(1),
    mail_encoding                      VARCHAR(50)  NOT NULL,
    save_address                      VARCHAR(1) ,
    cc_bcc                              VARCHAR(1),
    detail_option                        VARCHAR(1) ,
    record_user_cd                     VARCHAR(50) NOT NULL,
    record_date                         VARCHAR(19) NOT NULL,
    PRIMARY KEY (account_cd)
);
CREATE TABLE wbm_manager_server
(
    login_group_id                     VARCHAR(20) NOT NULL,
    send_server                        VARCHAR(128) NOT NULL,
    send_port                           DECIMAL(15,0) NOT NULL,
    receive_server                    VARCHAR(128)  NOT NULL,
    receive_port                       DECIMAL(15,0) NOT NULL,
    server_type                        VARCHAR(1),
    display_amount                    VARCHAR(50) NOT NULL,
    record_user_cd                     VARCHAR(50) NOT NULL,
    record_date                         VARCHAR(19) NOT NULL,
    PRIMARY KEY (login_group_id)
);
CREATE TABLE wbm_account_column
(
    account_cd                        VARCHAR(20) NOT NULL,
    column_name                      VARCHAR(50) NOT NULL,
    server_type                        VARCHAR(1) NOT NULL,
    user_cd                             VARCHAR(50) NOT NULL,
    sort_key                            DECIMAL(15,0) NOT NULL,
    record_user_cd                    VARCHAR(50) NOT NULL,
    record_date                        VARCHAR(19) NOT NULL,
    PRIMARY KEY (account_cd,column_name,server_type)
);
CREATE TABLE wbm_rule
(
    rule_cd                               VARCHAR(20) NOT NULL,
    account_cd                         VARCHAR(20) NOT NULL,
    user_cd                              VARCHAR(50) NOT NULL,
    rule_name                           VARCHAR(128) NOT NULL,
    rule_condition                      VARCHAR(50),
    key_word                            VARCHAR(128),
    key_condition                      VARCHAR(50),
    rule_action                          VARCHAR(20),
    rule_operate                         VARCHAR(128),
    auto_rule                            VARCHAR(1),
    sort_key                             DECIMAL(15,0),
    record_user_cd                    VARCHAR(50) NOT NULL,
    record_date                         VARCHAR(19) NOT NULL,
    PRIMARY KEY (rule_cd)
);
CREATE TABLE wbm_account_info
(
    account_cd                        VARCHAR(20) NOT NULL,
    user_cd                             VARCHAR(50) NOT NULL,
    account                            VARCHAR(128) NOT NULL,
    from_name                          VARCHAR(128) NOT NULL,
    mail_addr                            VARCHAR(128) NOT NULL,
    send_server                        VARCHAR(128) NOT NULL,
    send_port                           DECIMAL(15,0) NOT NULL,
    receive_server                     VARCHAR(128) NOT NULL,
    receive_port                        DECIMAL(15,0) NOT NULL,
    server_type                         VARCHAR(1),
    mail_account                      VARCHAR(128) NOT NULL,
    mail_pwd                          VARCHAR(256) NOT NULL,
    default_flg                           VARCHAR(1),
    quote                                VARCHAR(50) NOT NULL,
    sign                                 VARCHAR(2000),
    display_amount                    VARCHAR(50) NOT NULL,
    open_confirm                      VARCHAR(1),
    mail_to_self                         VARCHAR(1),
    smtp_auth                           VARCHAR(1),
    pop_before_smtp                   VARCHAR(1),
    auth_account                       VARCHAR(128),
    auth_pwd                            VARCHAR(256),
    pop_server                          VARCHAR(128),
    insert_user_cd                      VARCHAR(50) NOT NULL,
    insert_date                          VARCHAR(19) NOT NULL,    
    record_user_cd                     VARCHAR(50) NOT NULL,
    record_date                         VARCHAR(19) NOT NULL,
    PRIMARY KEY (account_cd)
);
CREATE TABLE wbm_address_history
(
    user_cd                             VARCHAR(50) NOT NULL,
    email_address                      VARCHAR(128) NOT NULL,
    record_user_cd                    VARCHAR(50) NOT NULL,
    record_date                        VARCHAR(19) NOT NULL,
    PRIMARY KEY (user_cd,email_address)
);
CREATE TABLE wbm_set_folder
(
    folder_cd                          VARCHAR(20) NOT NULL,
    account_cd                       VARCHAR(20) NOT NULL,
    user_cd                             VARCHAR(50) NOT NULL,
    folder_name                       VARCHAR(128),
    folder_type                         VARCHAR(1) ,
    record_user_cd                    VARCHAR(50) NOT NULL,
    record_date                        VARCHAR(19) NOT NULL,
    PRIMARY KEY (folder_cd)
);

ALTER TABLE ispm_portal ADD COLUMN todo_line DECIMAL(3,0);
ALTER TABLE ispm_portal ADD COLUMN memo_line DECIMAL(3,0);
ALTER TABLE ispm_portal ADD COLUMN blog_ctgr_atcl_disp_line DECIMAL(3,0);
ALTER TABLE ispm_portal ADD COLUMN blog_frnd_atcl_disp_line DECIMAL(3,0);
ALTER TABLE ispm_portal ADD COLUMN blog_msg_disp_line DECIMAL(3,0);
ALTER TABLE ispm_sea_exist_status ADD COLUMN isout VARCHAR(4);
ALTER TABLE ispt_todo_info ADD COLUMN send_mobile_mail_flg VARCHAR(4);
ALTER TABLE ispt_todo_notice_history ADD COLUMN send_mobile_mail_flg VARCHAR(4);
