/*
 * DatabaseReader.java
 *
 * Created on 2005/05/17,  18:26:58
 */
package jp.co.intra_mart.data_migration.common.read.database;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;
import jp.co.intra_mart.data_migration.common.read.CreateRowsException;
import jp.co.intra_mart.data_migration.common.read.Rows;
import jp.co.intra_mart.data_migration.common.read.RowsBuilder;
import jp.co.intra_mart.data_migration.common.util.DbUtil;

/**
 * f[^x[X\`f[^𐶐܂B
 * 
 * @author intra-mart
 * @since 5.0
 */
public  class DatabaseReader extends ConnectionProvider {
    /**
     * \`f[^NX
     */
    private RowsBuilder builder = new ResultSetRowsBuilderImpl();
    
    /**
     * f[^x[XǍ݂܂B
     * 
     * @param connection
     *            JDBCRlNV
     * @param sql
     *            SQL
     * @param parameters
     *            SQLɐݒ肷錟p[^
     * @return \`̃f[^
     * @throws CreateRowsException \`f[^̐Ɏsꍇ
     * @throws SQLException f[^x[Xŉ炩̗Oꍇ
     */
    public Rows read(Connection connection, String sql, List parameters)
            throws CreateRowsException, SQLException {

        PreparedStatement statement = null;
        ResultSet resultSet = null;
        try {
            statement = DbUtil.prepare(connection, sql, parameters);
            resultSet = DbUtil.executeQuery(statement);
            return builder.create(resultSet);
        } finally {
            DbUtil.close(statement, resultSet);
        }
    }
    
    /**
     * f[^x[XǍ݂܂B
     * 
     * @param connection
     *            JDBCRlNV
     * @param sql
     *            SQL
     * @return \`̃f[^
     * @throws CreateRowsException \`f[^̐Ɏsꍇ
     * @throws SQLException f[^x[Xŉ炩̗Oꍇ
     */
    public Rows read(Connection connection, PreparedStatement sql)
            throws CreateRowsException, SQLException {

        ResultSet resultSet = null;
        try {
            resultSet = DbUtil.executeQuery(sql);
            return builder.create(resultSet);
        } finally {
            DbUtil.close(sql, resultSet);
        }
    }
    
    /**
     * {@link RowsBuilder} ݒ肵܂B
     * 
     * @param builder RowsBuilder
     */
    protected void setRowsBuilder(RowsBuilder builder) {
        this.builder = builder;
    }
}