/*
 * DbUtil.java
 *
 * Created on 2005/05/17,  18:30:35
 */
package jp.co.intra_mart.data_migration.common.util;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Iterator;
import java.util.List;

/**
 * 
 * 
 * @author intra-mart
 * @since 5.0
 */
public class DbUtil {
    /**
     * RXgN^
     */
    private DbUtil() {
    }

    /**
     * {@link PreparedStatement} 𐶐܂B
     * 
     * @param connection
     *            java.sql.Connection
     * @param sql
     *            SQL
     * @param parameters
     *            p[^̃Xg
     * @return PreparedStatement
     */
    public static PreparedStatement prepare(Connection connection, String sql,
            List parameters) throws SQLException {
        PreparedStatement statement = connection.prepareStatement(sql);
        setParameter(statement, parameters);
        return statement;
    }

    /**
     * SQLŎgpp[^ݒ肵܂B
     * 
     * @param statement
     *            java.sql.PreparedStatement
     * @param parameters
     *            p[^̃Xg
     * @throws SQLException
     */
    public static void setParameter(PreparedStatement statement, List parameters)
            throws SQLException {
        if (parameters == null) {
            return;
        }
        Iterator it = parameters.iterator();
        int column = 1;
        while (it.hasNext()) {
            statement.setObject(column, it.next());
            column++;
        }
    }

    /**
     * sČʂXg`ɂĕԂ܂B
     * 
     * @param statement
     *            java.sql.PreparedStatement
     * @return java.sql.ResultSet
     * @throws SQLException
     *             Ɏsꍇ
     */
    public static ResultSet executeQuery(PreparedStatement statement)
            throws SQLException {
        return statement.executeQuery();
    }

    /**
     * {@link Statement}  {@link ResultSet} I܂B
     * 
     * @param statement
     *            java.sql.Statement
     * @param resultSet
     *            java.sql.ResultSet
     * @throws SQLException
     *             IɎsꍇ
     */
    public static void close(Statement statement, ResultSet resultSet)
            throws SQLException {
        close(resultSet);
        close(statement);
    }

    /**
     * {@link PreparedStatement}  {@link ResultSet} I܂B
     * 
     * @param statement
     *            java.sql.PreparedStatement
     * @param resultSet
     *            java.sql.ResultSet
     * @throws SQLException
     *             IɎsꍇ
     */
    public static void close(PreparedStatement statement, ResultSet resultSet)
            throws SQLException {
        close(resultSet);
        close(statement);
    }
    
    /**
     * {@link Connection} I܂B
     * 
     * @param connection
     *            java.sql.Connection
     * @throws SQLException
     */
    public static void close(Connection connection)
            throws SQLException {
        if (connection != null && !connection.isClosed()) {
            connection.close();
        }
    }

    /**
     * {@link Statement} I܂B
     * 
     * @param statement
     *            java.sql.Statement
     * @throws SQLException
     *             IɎsꍇ
     */
    public static void close(Statement statement)
            throws SQLException {
        if (statement != null) {
            statement.close();
        }
    }
    
    /**
     * {@link PreparedStatement} I܂B
     * 
     * @param statement
     *            java.sql.PreparedStatement
     * @throws SQLException
     *             IɎsꍇ
     */
    public static void close(PreparedStatement statement)
            throws SQLException {
        if (statement != null) {
            statement.close();
        }
    }

    /**
     * {@link ResultSet} I܂B
     * 
     * @param resultSet
     *            java.sql.ResultSet
     * @throws SQLException
     *             IɎsꍇ
     */
    public static void close(ResultSet resultSet) throws SQLException {
        if (resultSet != null) {
            resultSet.close();
        }
    }
    
    /**
     * {@link ResultSet} I܂B
     * 
     * @param resultSet
     *            java.sql.ResultSet
     * @throws getPaddingString
     *             IɎsꍇ
     */
	public static String getPaddingString(String val, int len) {
		int i = 0;
		StringBuffer sb = new StringBuffer();

		sb.append(val);
		for (i = val.length(); i < len; i++) {
			sb.append(" ");
		}
		return sb.toString();
	}
}