/*
 * XmlUtil.java
 *
 * Created on 2005/05/17,  21:04:06
 */
package jp.co.intra_mart.data_migration.common.util;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;

/**
 * XML֘Ã[eBeBłB
 * 
 * @author intra-mart
 * @since 5.0
 */
public class XmlUtil {

    /**
     * RXgN^
     */
    private XmlUtil() {
    }

    /**
     * XMLhLg擾܂B
     * 
     * @return XMLhLg
     * @throws ParserConfigurationException
     */
    public static Document getDocument() throws ParserConfigurationException {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        return builder.newDocument();
    }

    /**
     * XMLt@C̓ǂݍ݂s܂B
     * 
     * @param stream
     *            ̓Xg[
     * @return XMLhLg
     * @throws ParserConfigurationException
     * @throws SAXException
     * @throws IOException
     */
    public static Document read(InputStream stream)
            throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        return builder.parse(stream);
    }

    /**
     * XMLt@C̐s܂B
     * 
     * @param document
     *            XMLhLg
     * @param stream
     *            o̓Xg[
     * @throws TransformerException
     */
    public static void write(Document document, OutputStream stream)
            throws TransformerException {
        TransformerFactory factory = TransformerFactory.newInstance();
        Transformer transformer = factory.newTransformer();
        DOMSource source = new DOMSource(document);
        // oXMLt@Cݒ
        StreamResult target = new StreamResult(stream);
        // ϊ
        transformer.setOutputProperty(OutputKeys.INDENT, "yes");
        transformer.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
        transformer.setOutputProperty(OutputKeys.ENCODING, "UTF-8");
        transformer.transform(source, target);
    }
}