/*
 * Created on Jul 6, 2005
 *
 */
package jp.co.intra_mart.data_migration.generator.schedule;

import java.io.IOException;
import java.io.Writer;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.ArrayList;

import jp.co.intra_mart.data_migration.InsertFileWriter;
import jp.co.intra_mart.data_migration.common.BMCommon;
import jp.co.intra_mart.data_migration.common.initialContext;
import jp.co.intra_mart.data_migration.common.read.CreateRowsException;
import jp.co.intra_mart.data_migration.common.read.Rows;
import jp.co.intra_mart.data_migration.common.read.database.DatabaseReader;
import jp.co.intra_mart.data_migration.common.table.ColumnInfo;
import jp.co.intra_mart.data_migration.common.table.ISPGeneratorAdaptor;
import jp.co.intra_mart.data_migration.common.util.StringUtil;

/**
 * @author mouy
 * 
 * XPW[ANZXo^NX
 */
public class ScheduleAuthority extends ISPGeneratorAdaptor {
	//XPW[J}X^i[pRows
	Rows rowsPublic = null;
	//XPW[㗝l}X^i[pRows
	Rows rowsSubUser = null;

	ArrayList arrayUserID = new ArrayList();

	private static final ColumnInfo[] COLUMNS_PERSONAL_ACCESS = {
		/*
			CREATE TABLE ISPM_PERSONAL_ACCESS
			(
			    USER_CD                        VARCHAR2(50) NOT NULL,
			    INITIAL_STATUS                 VARCHAR2(3) NOT NULL,
			    RECORD_DATE                    VARCHAR2(19) NOT NULL,
			    RECORD_USER_CD                 VARCHAR2(50) NOT NULL
			)
		 */
		//[UR[h
		new ColumnInfo("user_cd",                   "varchar2(50)",true,false,false,false),
		//	                    
		new ColumnInfo("initial_status",            "varchar2(3)",false,false,false,false),
		//XV	                    
		new ColumnInfo("record_date",               "varchar2(19)",false,false,false,false),
		//XV[UR[h              
		new ColumnInfo("record_user_cd",            "varchar2(50)",false,false,false,false),
	};

	private static final ColumnInfo[] COLUMNS_PERSONAL_ACCESS_GROUP = {
		/*
				create table ISPM_PERSONAL_ACCESS_GROUP
				(
					USER_CD        VARCHAR2(50) not null,
					GROUP_CD       VARCHAR2(20) not null,
					ACCESS_LEVEL   VARCHAR2(3) not null,
					RECORD_USER_CD VARCHAR2(50) not null,
					RECORD_DATE    VARCHAR2(19) not null
				)*/
		//[UR[h
		new ColumnInfo("user_cd",         "varchar2(50)",true,false,false,false),
		//Ώۃ[UR[h(FK)
		new ColumnInfo("group_cd",        "varchar2(20)",true,false,false,false),
		//ANZX
		new ColumnInfo("access_level",    "varchar2(3)",false,false,false,false),
		//XV[UR[h
		new ColumnInfo("record_user_cd",  "varchar2(50)",false,false,false,false),
		//XV
		new ColumnInfo("record_date",     "varchar2(19)",false,false,false,false),	

	};

	private static final ColumnInfo[] COLUMNS_PERSONAL_ACCESS_USER = {
		/*
			 create table ISPM_PERSONAL_ACCESS_USER
			(
			  USER_CD        VARCHAR2(50) not null,
			  SUB_USER_CD    VARCHAR2(50) not null,
			  ACCESS_LEVEL   VARCHAR2(3) not null,
			  RECORD_USER_CD VARCHAR2(50) not null,
			  RECORD_DATE    VARCHAR2(19) not null
			)*/
		//[UR[h
		new ColumnInfo("user_cd",         "varchar2(50)",true,false,false,false),
		//Ώۃ[UR[h(FK)
		new ColumnInfo("sub_user_cd",     "varchar2(50)",true,false,false,false),
		//ANZX
		new ColumnInfo("access_level",    "varchar2(3)",false,false,false,false),
		//XV[UR[h
		new ColumnInfo("record_user_cd",  "varchar2(50)",false,false,false,false),
		//XV
		new ColumnInfo("record_date",     "varchar2(19)",false,false,false,false),			
	};
	ColumnInfo[] COLUMNS = null;

	public void createSQLFile(Writer out, Connection connection) throws IOException {

		DatabaseReader databaseReader = new DatabaseReader();

		//XPW[J}X^f[^擾B
		/*CREATE TABLE ISPM_SCHDL_PUBLIC
		(
		    GROUPING_CD                    VARCHAR2(20) NOT NULL,
		    USER_CD                        VARCHAR2(20) NOT NULL,
		    PARENT_CD                      VARCHAR2(20),
		    CLS_CD                         VARCHAR2(20),
		    POST_CD                        VARCHAR2(20) NOT NULL,
		    PUBLIC_TYPE                    VARCHAR2(1) NOT NULL,
		    RECORD_USER_CD                 VARCHAR2(50) NOT NULL,
		    RECORD_DATE                    VARCHAR2(19) NOT NULL
		)*/

		PreparedStatement statementPublic = null;
		PreparedStatement statementSubUser = null;
		StringBuffer sqlPublic = new StringBuffer();
		sqlPublic.append("SELECT grouping_cd ,");
		sqlPublic.append("user_cd, ");
		sqlPublic.append("public_type, ");
		sqlPublic.append("record_user_cd, ");
		//---------------------------------------
		sqlPublic.append("record_date,  ");	
		sqlPublic.append("parent_cd, cls_cd ");
		sqlPublic.append("FROM ispm_schdl_public ");
		sqlPublic.append("WHERE cls_cd <> 'role' ");

		//XPW[㗝l}X^
		/*CREATE TABLE ISPM_SUBUSER_MNG
		(
		    USER_CD                        VARCHAR2(20) NOT NULL,
		    SUB_USER_CD                    VARCHAR2(20) NOT NULL,
		    RECORD_USER_CD                 VARCHAR2(20) NOT NULL,
		    RECORD_DATE                    VARCHAR2(19) NOT NULL
		)*/
		StringBuffer sqlSubUser  = new StringBuffer();
		sqlSubUser.append("select  user_cd ,");
		sqlSubUser.append("sub_user_cd ,");
		sqlSubUser.append("record_user_cd ,");
		sqlSubUser.append("record_date  from ispm_subuser_mng");

		try {
			statementPublic = connection.prepareStatement(sqlPublic.toString());
			statementSubUser	= connection.prepareStatement(sqlSubUser.toString());
		} catch (SQLException e1) {
			e1.printStackTrace();
			initialContext.getLogger().warning("SQL Exception!");
		}

		try {
			rowsPublic =  databaseReader.read(connection, statementPublic);
			rowsSubUser =  databaseReader.read(connection, statementSubUser);
		} catch (CreateRowsException e) {
			e.printStackTrace();
			initialContext.getLogger().warning("Create Rows Exception!");
		} catch (SQLException e) {
			e.printStackTrace();
			initialContext.getLogger().warning("SQL Exception!");
		}

		//ISPM_PERSONAL_ACCESS̓͂SQL擾
		COLUMNS =  COLUMNS_PERSONAL_ACCESS;
		String insertSQLPersonalAccess = createInsertBaseSQL();

		//ISPM_PERSONAL_ACCESS_GROUP̓͂SQL擾
		COLUMNS =  COLUMNS_PERSONAL_ACCESS_GROUP;
		setTablePrefix("ispm_personal_access_group");
		String insertSQLPersonalAccessGroup = createInsertBaseSQL();

		//COLUMNS_PERSONAL_ACCESS_USER
		COLUMNS =  COLUMNS_PERSONAL_ACCESS_USER;
		setTablePrefix("ispm_personal_access_user");
		String insertSQLPersonalAccessUser = createInsertBaseSQL();

		// lANZX}X^FileWriter
		InsertFileWriter userAccessWriter = new InsertFileWriter();
		userAccessWriter.setTableName("ispm_personal_access");
		
		// lANZXO[v}X^FileWriter
		InsertFileWriter userAccessGroupWriter = new InsertFileWriter();
		userAccessGroupWriter.setTableName("ispm_personal_access_group");
		
		// lANZX[U}X^FileWriter
		InsertFileWriter userAccessUserWriter = new InsertFileWriter();
		userAccessUserWriter.setTableName("ispm_personal_access_user");
		
		StringBuffer record;
		
		// XPW[J}X^̃f[^lANZXO[v}X^ƌlANZX}X^̃f[^쐬
		for (int i = 1; i < rowsPublic.size()+1; i++) {
			//J^Cvu0:Ev̏ꍇAڍsȂB@@A1:gD
			if(rowsPublic.getColumns(i).getString(3).equals("0")){
				continue;
			}

			String groupingCD =  rowsPublic.getColumns(i).getString(1);
			String parentCD =  rowsPublic.getColumns(i).getString(6);

			int flagGet = 1;
			//XPW[J}X^.O[sOR[h -> lANZXO[v}X^.O[vR[h															
			String groupCD= BMCommon.getGroupCD(groupingCD ,parentCD , flagGet,
					rowsPublic.getColumns(i).getString(4),
					rowsPublic.getColumns(i).getString(5),
					rowsPublic.getColumns(i).getString(7),
					connection);
			
			record = new StringBuffer();
			record.append(insertSQLPersonalAccessGroup);

			//USER_CD                        VARCHAR2(50) NOT NULL,
			record.append(StringUtil.TrimNull(rowsPublic.getColumns(i).getString(2)) + ", ");

			//GROUP_CD       VARCHAR2(20) not null,
			record.append(StringUtil.TrimNull(groupCD)+", ");

			//ACCESS_LEVEL   VARCHAR2(3) not null,@QƉ:30
			record.append("'40', ");

			//RECORD_USER_CD VARCHAR2(50) not null,
			record.append(StringUtil.TrimNull(rowsPublic.getColumns(i).getString(4)) + ", ");

			//RECORD_DATE    VARCHAR2(19) not null
			record.append(StringUtil.TrimNull(rowsPublic.getColumns(i).getString(5)) + ");\n");
			
			userAccessGroupWriter.addRecord(record.toString());

			//----------------------------------

			//XPW[J}X^.[UR[h->lANZX}X^.[UR[h														
			//USER_CD                        VARCHAR2(50) NOT NULL,
			String targetUserCd = StringUtil.TrimNull(rowsPublic.getColumns(i).getString(2)).toString();
			record = new StringBuffer();
			
			if(!arrayUserID.contains(targetUserCd)){
				// f[^܂o^ĂȂꍇ
				arrayUserID.add(targetUserCd);
				
				record.append(insertSQLPersonalAccess);
				// ispm_personal_accessւ̓o^
				// USER_CD
				record.append(StringUtil.TrimNull(rowsPublic.getColumns(i).getString(2)) + ", ");
				// INITIAL_STATUS  ŒlF:10
				record.append("'10', ");
				// RECORD_DATE                    VARCHAR2(19) NOT NULL,
				record.append(StringUtil.TrimNull(rowsPublic.getColumns(i).getString(5)) + ", ");
				// RECORD_USER_CD                 VARCHAR2(50) NOT NULL
				record.append(StringUtil.TrimNull(rowsPublic.getColumns(i).getString(4)) + ");\n");
				
				// f[^̏
				userAccessWriter.addRecord(record.toString());
			}
		}

		// 㗝l}X^AlANZX[U}X^ƌlANZX}X^̍쐬
		for (int i = 1; i < rowsSubUser.size()+1; i++) {
			record = new StringBuffer();
			
			record.append(insertSQLPersonalAccessUser);
			
			//USER_CD        VARCHAR2(50) not null,
			//XPW[㗝l}X^.[UR[h	lANZX[U}X^.[UR[h	
			record.append(StringUtil.TrimNull(rowsSubUser.getColumns(i).getString(1)) + ", ");
			//SUB_USER_CD    VARCHAR2(50) not null,
			record.append(StringUtil.TrimNull(rowsSubUser.getColumns(i).getString(2)) + ", ");
			//ACCESS_LEVEL   VARCHAR2(3) not null,鏑:50
			record.append("'50', ");
			//RECORD_USER_CD VARCHAR2(50) not null,
			record.append(StringUtil.TrimNull(rowsSubUser.getColumns(i).getString(3)) + ", ");
			//RECORD_DATE    VARCHAR2(19) not null
			record.append(StringUtil.TrimNull(rowsSubUser.getColumns(i).getString(4)) + ");\n");

			// f[^̏
			userAccessUserWriter.addRecord(record.toString());
			
			record = new StringBuffer();
			
			String targetUserCd = StringUtil.TrimNull(rowsSubUser.getColumns(i).getString(1));
			
			if(!arrayUserID.contains(targetUserCd)){
				arrayUserID.add(targetUserCd);
				
				// vtBbNX
				record.append(insertSQLPersonalAccess);
				
				// user_cd
				record.append(StringUtil.TrimNull(rowsSubUser.getColumns(i).getString(1)) + ", ");
				//INITIAL_STATUS  ŒlF:10
				record.append("'40', ");
				//RECORD_DATE                    VARCHAR2(19) NOT NULL,
				record.append(StringUtil.TrimNull(rowsSubUser.getColumns(i).getString(4)) + ", ");
				//RECORD_USER_CD                 VARCHAR2(50) NOT NULL
				record.append(StringUtil.TrimNull(rowsSubUser.getColumns(i).getString(3)) + ");\n");
				
				// f[^̏
				userAccessWriter.addRecord(record.toString());
			}
		}
		
		userAccessWriter.close();
		userAccessGroupWriter.close();
		userAccessUserWriter.close();
	}

	public ColumnInfo[] getColumnInfos() {
		return COLUMNS;
	}
}