/*
 * GeneratorAdaptor.java
 *
 * Created on 2005/02/02, 15:33:24
 */
package jp.co.intra_mart.data_migration.common.table;

import java.io.Writer;
import java.io.IOException;
import jp.co.intra_mart.data_migration.common.table.GeneratorConstant;

/**
 * GeBeB̃f[^𐶐܂B
 * 
 * @author ohyama
 * @since 5.0
 */
public abstract class ISPGeneratorAdaptor implements TableGenerator {

    /**
     * e[ũvtBbNX
     */
    private String tablePrefix;

    /**
     * e[ũvtBbNX擾܂B
     * 
     * @return e[ũvtBbNX
     */
    public String getTablePrefix() {
        return this.tablePrefix;
    }

    /**
     * e[ũvtBbNXݒ肵܂B
     * 
     * @param prefix e[ũvtBbNX
     */
    public void setTablePrefix(String prefix) {
        this.tablePrefix = prefix;
    }

    /**
     * {e[uDROP擾܂B
     * 
     * @return {e[uDROP
     */
    public String getDropBaseTableDDL() {
        if (GeneratorConstant.DROP_TABLE_FLAG) {
            return "DROP TABLE " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_BASE + ";";
        } else {
            return "DELETE FROM " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_BASE + ";";
        }
    }

    /**
     * {e[uCREATE擾܂B
     * 
     * @return {e[uCREATE
     */
    public String getCreateBaseTableDDL() {
        if (GeneratorConstant.DROP_TABLE_FLAG) {
            String sql = "";
            boolean isFirst = true;
            ColumnInfo[] columns = getColumnInfos();

            sql += "CREATE TABLE " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_BASE + " ";
            for (int i = 0; i < columns.length; i++) {
                if (columns[i].isPrimaryKey() || !columns[i].isTerminable()
                        && !columns[i].isInternational()) {
                    if (isFirst) {
                        isFirst = false;
                        sql += "(";
                    } else {
                        sql += ", ";
                    }
                    sql += columns[i].getName() + " " + columns[i].getType();
                    if (!columns[i].isNullAcceptable()) {
                        sql += " NOT NULL";
                    }
                }
            }
            sql += ", " + GeneratorConstant.COLUMN_NAME_RECORD_USER_CD + " "
                    + GeneratorConstant.COLUMN_TYPE_RECORD_USER_CD + ", "
                    + GeneratorConstant.COLUMN_NAME_RECORD_DATE + " "
                    + GeneratorConstant.COLUMN_TYPE_RECORD_DATE + ");";

            return sql;
        } else {
            return "";
        }
    }

    /**
     * {e[uALTER擾܂B
     * 
     * @return {e[uALTER
     */
    public String getAlterBaseTableDDL() {
        if (GeneratorConstant.DROP_TABLE_FLAG) {
            String sql = "";
            boolean isFirst = true;
            ColumnInfo[] columns = getColumnInfos();

            sql += "ALTER TABLE " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_BASE + " ADD PRIMARY KEY";
            for (int i = 0; i < columns.length; i++) {
                if (columns[i].isPrimaryKey()) {
                    if (isFirst) {
                        sql += "(";
                        isFirst = false;
                    } else {
                        sql += ", ";
                    }
                    sql += columns[i].getName();
                }
            }
            sql += ");";

            return sql;
        } else {
            return "";
        }
    }

    /**
     * ԉe[uDROP擾܂B
     * 
     * @return ԉe[uDROP
     */
    public String getDropTermTableDDL() {
        if (GeneratorConstant.DROP_TABLE_FLAG) {
            return "DROP TABLE " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_TERM + ";";
        } else {
            return "DELETE FROM " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_TERM + ";";
        }
    }

    /**
     * ԉe[uCREATE擾܂B
     * 
     * @return ԉe[uCREATE
     */
    public String getCreateTermTableDDL() {
        if (GeneratorConstant.DROP_TABLE_FLAG) {
            String sql = "";
            boolean isFirst = true;
            ColumnInfo[] columns = getColumnInfos();
            boolean isPrimaryKeyFinished = false;

            sql += "CREATE TABLE " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_TERM + " ";
            for (int i = 0; i < columns.length; i++) {
                if (columns[i].isPrimaryKey() || columns[i].isTerminable()
                        && !columns[i].isInternational()) {
                    if (isFirst) {
                        sql += "(";
                        isFirst = false;
                    } else {
                        sql += ", ";
                    }
                    if (!columns[i].isPrimaryKey() && !isPrimaryKeyFinished) {
                        isPrimaryKeyFinished = true;
                        sql += GeneratorConstant.COLUMN_NAME_TERM + " "
                                + GeneratorConstant.COLUMN_TYPE_TERM + ", "
                                + GeneratorConstant.COLUMN_NAME_START_DATE
                                + " "
                                + GeneratorConstant.COLUMN_TYPE_START_DATE
                                + ", " + GeneratorConstant.COLUMN_NAME_END_DATE
                                + " " + GeneratorConstant.COLUMN_TYPE_END_DATE
                                + ", ";
                    }
                    sql += columns[i].getName() + " " + columns[i].getType();
                    if (!columns[i].isNullAcceptable()) {
                        sql += " NOT NULL";
                    }
                }
            }
            if (!isPrimaryKeyFinished) {
                sql += ", " + GeneratorConstant.COLUMN_NAME_TERM + " "
                        + GeneratorConstant.COLUMN_TYPE_TERM + ", "
                        + GeneratorConstant.COLUMN_NAME_START_DATE + " "
                        + GeneratorConstant.COLUMN_TYPE_START_DATE + ", "
                        + GeneratorConstant.COLUMN_NAME_END_DATE + " "
                        + GeneratorConstant.COLUMN_TYPE_END_DATE;
            }
            sql += ");";

            return sql;
        } else {
            return "";
        }
    }

    /**
     * ԉe[uALTER擾܂B
     * 
     * @return ԉe[uALTER
     */
    public String getAlterTermTableDDL() {
        if (GeneratorConstant.DROP_TABLE_FLAG) {
            String sql = "";
            boolean isFirst = true;
            ColumnInfo[] columns = getColumnInfos();

            sql += "ALTER TABLE " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_TERM + " ADD PRIMARY KEY";
            for (int i = 0; i < columns.length; i++) {
                if (columns[i].isPrimaryKey()) {
                    if (isFirst) {
                        sql += "(";
                        isFirst = false;
                    } else {
                        sql += ", ";
                    }
                    sql += columns[i].getName();
                }
            }
            sql += ", " + GeneratorConstant.COLUMN_NAME_TERM + ");";

            return sql;
        } else {
            return "";
        }
    }

    /**
     * ۉe[uDROP擾܂B
     * 
     * @return ԉe[uDROP
     */
    public String getDropI18nTableDDL() {
        if (GeneratorConstant.DROP_TABLE_FLAG) {
            return "DROP TABLE " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_I18N + ";";
        } else {
            return "DELETE FROM " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_I18N + ";";
        }
    }

    /**
     * ۉe[uCREATE擾܂B
     * 
     * @return ۉe[uCREATE
     */
    public String getCreateI18nTableDDL() {
        if (GeneratorConstant.DROP_TABLE_FLAG) {
            String sql = "";
            boolean isFirst = true;
            ColumnInfo[] columns = getColumnInfos();
            boolean isPrimaryKeyFinished = false;

            sql += "CREATE TABLE " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_I18N + " ";
            for (int i = 0; i < columns.length; i++) {
                if (columns[i].isPrimaryKey() || !columns[i].isTerminable()
                        && columns[i].isInternational()) {
                    if (isFirst) {
                        sql += "(";
                        isFirst = false;
                    } else {
                        sql += ", ";
                    }
                    if (!columns[i].isPrimaryKey() && !isPrimaryKeyFinished) {
                        isPrimaryKeyFinished = true;
                        sql += GeneratorConstant.COLUMN_NAME_I18N + " "
                                + GeneratorConstant.COLUMN_TYPE_I18N + ", ";
                    }
                    sql += columns[i].getName() + " " + columns[i].getType();
                    if (!columns[i].isNullAcceptable()) {
                        sql += " NOT NULL";
                    }
                }
            }
            if (!isPrimaryKeyFinished) {
                sql += ", " + GeneratorConstant.COLUMN_NAME_I18N + " "
                        + GeneratorConstant.COLUMN_TYPE_I18N;
            }
            sql += ");";

            return sql;
        } else {
            return "";
        }
    }

    /**
     * ۉe[uALTER擾܂B
     * 
     * @return ۉe[uALTER
     */
    public String getAlterI18nTableDDL() {
        if (GeneratorConstant.DROP_TABLE_FLAG) {
            String sql = "";
            boolean isFirst = true;
            ColumnInfo[] columns = getColumnInfos();

            sql += "ALTER TABLE " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_I18N + " ADD PRIMARY KEY";
            for (int i = 0; i < columns.length; i++) {
                if (columns[i].isPrimaryKey()) {
                    if (isFirst) {
                        sql += "(";
                        isFirst = false;
                    } else {
                        sql += ", ";
                    }
                    sql += columns[i].getName();
                }
            }
            sql += ", " + GeneratorConstant.COLUMN_NAME_I18N + ");";

            return sql;
        } else {
            return "";
        }
    }

    /**
     * ԍۉe[uDROP擾܂B
     * 
     * @return ԍۉe[uDROP
     */
    public String getDropTermI18nTableDDL() {
        if (GeneratorConstant.DROP_TABLE_FLAG) {
            return "DROP TABLE " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_TERM_I18N + ";";

        } else {
            return "DELETE FROM " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_TERM_I18N + ";";
        }
    }

    /**
     * ԍۉe[uCREATE擾܂B
     * 
     * @return ԍۉe[uCREATE
     */
    public String getCreateTermI18nTableDDL() {
        if (GeneratorConstant.DROP_TABLE_FLAG) {
            String sql = "";
            boolean isFirst = true;
            ColumnInfo[] columns = getColumnInfos();
            boolean isPrimaryKeyFinished = false;

            sql += "CREATE TABLE " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_TERM_I18N + " ";
            for (int i = 0; i < columns.length; i++) {
                if (columns[i].isPrimaryKey() || columns[i].isTerminable()
                        && columns[i].isInternational()) {
                    if (isFirst) {
                        sql += "(";
                        isFirst = false;
                    } else {
                        sql += ", ";
                    }
                    if (!columns[i].isPrimaryKey() && !isPrimaryKeyFinished) {
                        isPrimaryKeyFinished = true;
                        sql += GeneratorConstant.COLUMN_NAME_TERM + " "
                                + GeneratorConstant.COLUMN_TYPE_TERM + ", "
                                + GeneratorConstant.COLUMN_NAME_I18N + " "
                                + GeneratorConstant.COLUMN_TYPE_I18N + ", ";
                    }
                    sql += columns[i].getName() + " " + columns[i].getType();
                    if (!columns[i].isNullAcceptable()) {
                        sql += " NOT NULL";
                    }
                }
            }
            if (!isPrimaryKeyFinished) {
                sql += "," + GeneratorConstant.COLUMN_NAME_TERM + " "
                        + GeneratorConstant.COLUMN_TYPE_TERM + ", "
                        + GeneratorConstant.COLUMN_NAME_I18N + " "
                        + GeneratorConstant.COLUMN_TYPE_I18N;
            }
            sql += ");";

            return sql;
        } else {
            return "";
        }
    }

    /**
     * ԍۉe[uALTER擾܂B
     * 
     * @return ԉe[uALTER
     */
    public String getAlterTermI18nTableDDL() {
        if (GeneratorConstant.DROP_TABLE_FLAG) {
            String sql = "";
            boolean isFirst = true;
            ColumnInfo[] columns = getColumnInfos();

            sql += "ALTER TABLE " + getTablePrefix()
                    + GeneratorConstant.TABLE_SUFFIX_TERM_I18N
                    + " ADD PRIMARY KEY";
            for (int i = 0; i < columns.length; i++) {
                if (columns[i].isPrimaryKey()) {
                    if (isFirst) {
                        sql += "(";
                        isFirst = false;
                    } else {
                        sql += ", ";
                    }
                    sql += columns[i].getName();
                }
            }
            sql += ", " + GeneratorConstant.COLUMN_NAME_TERM + ", "
                    + GeneratorConstant.COLUMN_NAME_I18N + ");";

            return sql;
        } else {
            return "";
        }
    }

    /**
     * {e[uINSERT𐶐܂B
     * 
     * @return INSERŤŒ蕔
     */
    public String createInsertBaseSQL() {
        String sql = "";
        boolean isFirst = true;
        ColumnInfo[] columns = getColumnInfos();

        sql = "INSERT INTO " + getTablePrefix()
                + " ";
        for (int i = 0; i < columns.length; i++) {
            if (columns[i].isPrimaryKey() || !columns[i].isTerminable()
                    && !columns[i].isInternational()) {
                if (isFirst) {
                    isFirst = false;
                    sql += "(";
                } else {
                    sql += ", ";
                }
                sql += columns[i].getName();
            }
        }
        sql += ") VALUES (";

        return sql;
    }

    /**
     * ԉe[uINSERT𐶐܂B
     * 
     * @return INSERŤŒ蕔
     */
    public String createInsertTerminableSQL() {
        String sql = "";
        boolean isFirst = true;
        ColumnInfo[] columns = getColumnInfos();
        boolean isPrimaryKeyFinished = false;

        sql = "INSERT INTO " + getTablePrefix()
                + GeneratorConstant.TABLE_SUFFIX_TERM + " ";
        for (int i = 0; i < columns.length; i++) {
            if (columns[i].isPrimaryKey() || columns[i].isTerminable()
                    && !columns[i].isInternational()) {
                if (isFirst) {
                    isFirst = false;
                    sql += "(";
                } else {
                    sql += ", ";
                }
                if (!columns[i].isPrimaryKey() && !isPrimaryKeyFinished) {
                    isPrimaryKeyFinished = true;
                    sql += GeneratorConstant.COLUMN_NAME_TERM
                            + ", start_date, end_date, ";
                }
                sql += columns[i].getName();
            }
        }
        if (!isPrimaryKeyFinished) {
            sql += ", " + GeneratorConstant.COLUMN_NAME_TERM
                    + ", start_date, end_date";
        }
        sql += ") VALUES (";

        return sql;
    }

    /**
     * ۉe[uINSERT𐶐܂B
     * 
     * @return INSERŤŒ蕔
     */
    public String createInsertInternationalSQL() {
        String sql = "";
        boolean isFirst = true;
        ColumnInfo[] columns = getColumnInfos();
        boolean isPrimaryKeyFinished = false;

        sql = "INSERT INTO " + getTablePrefix()
                + GeneratorConstant.TABLE_SUFFIX_I18N + " ";
        for (int i = 0; i < columns.length; i++) {
            if (columns[i].isPrimaryKey() || !columns[i].isTerminable()
                    && columns[i].isInternational()) {
                if (isFirst) {
                    isFirst = false;
                    sql += "(";
                } else {
                    sql += ", ";
                }
                if (!columns[i].isPrimaryKey() && !isPrimaryKeyFinished) {
                    isPrimaryKeyFinished = true;
                    sql += GeneratorConstant.COLUMN_NAME_I18N + ", ";
                }
                sql += columns[i].getName();
            }
        }
        if (!isPrimaryKeyFinished) {
            sql += ", " + GeneratorConstant.COLUMN_NAME_I18N;
        }
        sql += ") VALUES (";

        return sql;
    }

    /**
     * ԍۉe[uINSERT𐶐܂B
     * 
     * @return INSERŤŒ蕔
     */
    public String createInsertTerminableInternationalSQL() {
        String sql = "";
        boolean isFirst = true;
        ColumnInfo[] columns = getColumnInfos();
        boolean isPrimaryKeyFinished = false;

        sql = "INSERT INTO " + getTablePrefix()
                + GeneratorConstant.TABLE_SUFFIX_TERM_I18N + " ";
        for (int i = 0; i < columns.length; i++) {
            if (columns[i].isPrimaryKey() || columns[i].isTerminable()
                    && columns[i].isInternational()) {
                if (isFirst) {
                    isFirst = false;
                    sql += "(";
                } else {
                    sql += ", ";
                }
                if (!columns[i].isPrimaryKey() && !isPrimaryKeyFinished) {
                    isPrimaryKeyFinished = true;
                    sql += GeneratorConstant.COLUMN_NAME_TERM + ", "
                            + GeneratorConstant.COLUMN_NAME_I18N + ", ";
                }
                sql += columns[i].getName();
            }
        }
        if (!isPrimaryKeyFinished) {
            sql += ", " + GeneratorConstant.COLUMN_NAME_TERM + ", "
                    + GeneratorConstant.COLUMN_NAME_I18N;
        }
        sql += ") VALUES (";

        return sql;
    }

    /**
     * ׂẴe[uSelect𐶐܂B
     * 
     * @return ׂẴe[uSelect
     */
    public String getSelectSQL() {
        String sql = "SELECT '" + getTablePrefix() + " 5.0', COUNT(*) FROM "
                + getTablePrefix() + "_b table_b";

                 return sql + ";";
    }

    /**
     * Ѝۉe[upinserto͂܂B
     * 
     * @param out o̓Xg[
     * @throws IOException o͒ɗO
     */
    public void putI18nStatement(Writer out) throws IOException {
    }

    /**
     * Њԉe[upinserto͂܂B
     * 
     * @param out o̓Xg[
     * @throws IOException o͒ɗO
     */
    public void putTermStatement(Writer out) throws IOException {
    }

    /**
     * Њԉe[upinserto͂܂B
     * 
     * @param out o̓Xg[
     * @throws IOException o͒ɗO
     */
    public void putTermI18nStatement(Writer out) throws IOException {
    }
}